// Auto-generated. Do not edit!

// (in-package cob_light.msg)


"use strict";

const _serializer = _ros_msg_utils.Serialize;
const _arraySerializer = _serializer.Array;
const _deserializer = _ros_msg_utils.Deserialize;
const _arrayDeserializer = _deserializer.Array;
const _finder = _ros_msg_utils.Find;
const _getByteLength = _ros_msg_utils.getByteLength;
let LightMode = require('./LightMode.js');

//-----------------------------------------------------------

class SetLightModeGoal {
  constructor(initObj={}) {
    if (initObj === null) {
      // initObj === null is a special case for deserialization where we don't initialize fields
      this.mode = null;
    }
    else {
      if (initObj.hasOwnProperty('mode')) {
        this.mode = initObj.mode
      }
      else {
        this.mode = new LightMode();
      }
    }
  }

  static serialize(obj, buffer, bufferOffset) {
    // Serializes a message object of type SetLightModeGoal
    // Serialize message field [mode]
    bufferOffset = LightMode.serialize(obj.mode, buffer, bufferOffset);
    return bufferOffset;
  }

  static deserialize(buffer, bufferOffset=[0]) {
    //deserializes a message object of type SetLightModeGoal
    let len;
    let data = new SetLightModeGoal(null);
    // Deserialize message field [mode]
    data.mode = LightMode.deserialize(buffer, bufferOffset);
    return data;
  }

  static getMessageSize(object) {
    let length = 0;
    length += LightMode.getMessageSize(object.mode);
    return length;
  }

  static datatype() {
    // Returns string type for a message object
    return 'cob_light/SetLightModeGoal';
  }

  static md5sum() {
    //Returns md5sum for a message object
    return 'cf64533ba011e7f531cecce5a35c9b83';
  }

  static messageDefinition() {
    // Returns full string definition for message
    return `
    # ====== DO NOT MODIFY! AUTOGENERATED FROM AN ACTION DEFINITION ======
    # The goal
    cob_light/LightMode mode
    
    ================================================================================
    MSG: cob_light/LightMode
    uint8 mode                         # mode to switch on
    
    float32                frequency   # in Hz
    float32                timeout     # in s, requested mode will be executed for max timeout s.
                                       # default is 0 and means no timeout.
    int32                  pulses      # specifies the amount of pulses which will be executed.
                                       # eg: mode = flash, pulses = 2. Means the light will flash two times
    int8                   priority    # priority [-20,20] default = 0. Modes with same or higher priorities will
                                       # be executed.
    std_msgs/ColorRGBA[]   colors      # array of colors.
                                       # size > 1: each color represent one led (size should match the amount of leds)
                                       # size = 1: one color for all leds or color for specific mode
                                       # size = 0: undefined
    cob_light/Sequence[]   sequences   # an array of sequence definitions, used only if mode is set to SEQ
    
    ================================================================================
    MSG: std_msgs/ColorRGBA
    float32 r
    float32 g
    float32 b
    float32 a
    
    ================================================================================
    MSG: cob_light/Sequence
    std_msgs/ColorRGBA   color       #sequence color
    float32              hold_time   #time how long the color should be hold [s]
    float32              cross_time  #time how long it take to fade to this color [s]
    `;
  }

  static Resolve(msg) {
    // deep-construct a valid message object instance of whatever was passed in
    if (typeof msg !== 'object' || msg === null) {
      msg = {};
    }
    const resolved = new SetLightModeGoal(null);
    if (msg.mode !== undefined) {
      resolved.mode = LightMode.Resolve(msg.mode)
    }
    else {
      resolved.mode = new LightMode()
    }

    return resolved;
    }
};

module.exports = SetLightModeGoal;
